<?xml version="1.0" encoding="ISO-8859-1"?>
<toc>
<book href="index.html" id="id5381065">
<title>MIPSpro&#8482; Assembly Language Programmer's Guide</title>
<bookinfo href="front.html">
<title>Front Matter</title>
</bookinfo>
<preface href="pr01.html" id="id5384645">
<title>New Features in This Manual</title>
</preface>
<preface href="pr02.html" id="id5178939">
<title>About This Guide</title>
<section href="pr02.html#Z845237088emily" id="Z845237088emily">
<title>Related Publications</title>
</section>
<section href="pr02.html#id5179120" id="id5179120">
<title>Obtaining Publications</title>
</section>
<section href="pr02.html#Z825545312melby" id="Z825545312melby">
<title>Conventions</title>
</section>
<section href="pr02.html#z825546061melby" id="z825546061melby">
<title>Reader Comments</title>
</section>
</preface>
<chapter href="ch01.html" id="id5179369">
<title>Chapter 1. Registers</title>
<section href="ch01.html#id5179395" id="id5179395">
<title>Register Format</title>
</section>
<section href="ch01.html#id5179481" id="id5179481">
<title>General Registers</title>
<table href="ch01.html#Z19384" id="Z19384">
<title>Table 1-1. General (Integer) Registers (-32)</title>
</table>
<table href="ch01.html#Z10891" id="Z10891">
<title>Table 1-2. General (Integer) Registers (64-Bit)</title>
</table>
</section>
<section href="ch01.html#id5177846" id="id5177846">
<title>Special Registers</title>
<table href="ch01.html#Z22783" id="Z22783">
<title>Table 1-3. Special Registers</title>
</table>
</section>
<section href="ch01.html#id5178068" id="id5178068">
<title>Floating-Point Registers</title>
<table href="ch01.html#Z98599" id="Z98599">
<title>Table 1-4. Floating-Point Registers (-32)</title>
</table>
<table href="ch01.html#id5178479" id="id5178479">
<title>Table 1-5. Floating-Point Registers (-64)</title>
</table>
<table href="ch01.html#Z84436" id="Z84436">
<title>Table 1-6. Floating-Point Registers (-n32)</title>
</table>
</section>
<section href="ch01.html#id5188216" id="id5188216">
<title>Floating-Point Condition Codes</title>
</section>
</chapter>
<chapter href="ch02.html" id="id5188252">
<title>Chapter 2. Addressing</title>
<section href="ch02.html#id5188299" id="id5188299">
<title>Instructions to Load and Store Unaligned Data</title>
</section>
<section href="ch02.html#id5188915" id="id5188915">
<title>Address Formats</title>
<table href="ch02.html#Z41417" id="Z41417">
<title>Table 2-1. Address Formats</title>
</table>
</section>
<section href="ch02.html#id5189227" id="id5189227">
<title>Address Descriptions</title>
<table href="ch02.html#Z10681" id="Z10681">
<title>Table 2-2. Assembler Addresses</title>
</table>
</section>
</chapter>
<chapter href="ch03.html" id="id5189604">
<title>Chapter 3. Exceptions</title>
<section href="ch03.html#id5189626" id="id5189626">
<title>Main Processor Exceptions</title>
</section>
<section href="ch03.html#id5189707" id="id5189707">
<title>Floating-Point Exceptions</title>
</section>
</chapter>
<chapter href="ch04.html" id="Z900600120swensona">
<title>Chapter 4. Lexical Conventions</title>
<section href="ch04.html#Z920574868jeanw" id="Z920574868jeanw">
<title>Tokens</title>
</section>
<section href="ch04.html#Z920574888jeanw" id="Z920574888jeanw">
<title>Comments</title>
</section>
<section href="ch04.html#Z920574916jeanw" id="Z920574916jeanw">
<title>Identifiers</title>
</section>
<section href="ch04.html#Z920574948jeanw" id="Z920574948jeanw">
<title>Constants</title>
<section href="ch04.html#id5190394" id="id5190394">
<title>Scalar Constants</title>
</section>
<section href="ch04.html#id5190489" id="id5190489">
<title>Floating-Point Constants</title>
</section>
<section href="ch04.html#id5190675" id="id5190675">
<title>String Constants</title>
<table href="ch04.html#Z20018" id="Z20018">
<title>Table 4-1. Backslash Conventions</title>
</table>
</section>
</section>
<section href="ch04.html#Z920574982jeanw" id="Z920574982jeanw">
<title>Multiple Lines Per Physical Line</title>
</section>
<section href="ch04.html#Z920575011jeanw" id="Z920575011jeanw">
<title>Section and Location Counters</title>
<figure href="ch04.html#Z14949" id="Z14949">
<title>Figure 4-1. Section and Location Counters</title>
</figure>
</section>
<section href="ch04.html#Z920575042jeanw" id="Z920575042jeanw">
<title>Statements</title>
<section href="ch04.html#id5191448" id="id5191448">
<title>Label Definitions</title>
</section>
<section href="ch04.html#id5191526" id="id5191526">
<title>Null Statements</title>
</section>
<section href="ch04.html#id5191560" id="id5191560">
<title>Keyword Statements</title>
</section>
</section>
<section href="ch04.html#Z920575072jeanw" id="Z920575072jeanw">
<title>Expressions</title>
<section href="ch04.html#id5191756" id="id5191756">
<title>Precedence</title>
</section>
<section href="ch04.html#id5191911" id="id5191911">
<title>Expression Operators</title>
<table href="ch04.html#Z29294" id="Z29294">
<title>Table 4-2. Expression Operators</title>
</table>
</section>
<section href="ch04.html#id5192416" id="id5192416">
<title>Data Types</title>
<table href="ch04.html#Z15316" id="Z15316">
<title>Table 4-3. Data Types</title>
</table>
</section>
<section href="ch04.html#id5193072" id="id5193072">
<title>Type Propagation in Expressions</title>
</section>
</section>
<section href="ch04.html#id5193220" id="id5193220">
<title>Relocations</title>
</section>
</chapter>
<chapter href="ch05.html" id="Z900603581swensona">
<title>Chapter 5. The Instruction Set</title>
<section href="ch05.html#id5193635" id="id5193635">
<title>Instruction Classes</title>
</section>
<section href="ch05.html#id5193777" id="id5193777">
<title>Reorganization Constraints and Rules</title>
</section>
<section href="ch05.html#id5193827" id="id5193827">
<title>Instruction Notation</title>
</section>
<section href="ch05.html#id5194208" id="id5194208">
<title>Instruction Set</title>
<section href="ch05.html#id5194240" id="id5194240">
<title>Load and Store Instructions</title>
<table href="ch05.html#Z78915" id="Z78915">
<title>Table 5-1. Load and Store Format Summary</title>
</table>
</section>
<section href="ch05.html#id5195938" id="id5195938">
<title>Load Instruction Descriptions</title>
<table href="ch05.html#Z51991" id="Z51991">
<title>Table 5-2. Load Instruction Descriptions</title>
</table>
<table href="ch05.html#Z88275" id="Z88275">
<title>Table 5-3. Load Instruction Descriptions for MIPS3/4 Architecture Only</title>
</table>
</section>
<section href="ch05.html#id5197072" id="id5197072">
<title>Store Instruction Descriptions</title>
<table href="ch05.html#Z16676" id="Z16676">
<title>Table 5-4. Store Instruction Descriptions</title>
</table>
<table href="ch05.html#Z88873" id="Z88873">
<title>Table 5-5. Store Instruction Descriptions for MIPS3/4 Architecture Only</title>
</table>
</section>
</section>
<section href="ch05.html#id5197876" id="id5197876">
<title>Computational Instructions</title>
<section href="ch05.html#id5197907" id="id5197907">
<title>Computational Instructions</title>
<table href="ch05.html#Z15026" id="Z15026">
<title>Table 5-6. Computational Format Summaries</title>
</table>
</section>
<section href="ch05.html#id5201007" id="id5201007">
<title>Computational Instruction Descriptions</title>
<table href="ch05.html#Z32540" id="Z32540">
<title>Table 5-7. Computational Instruction Descriptions</title>
</table>
<table href="ch05.html#Z45575" id="Z45575">
<title>Table 5-8. Computational Instruction Descriptions for MIPS3/4 Architecture </title>
</table>
</section>
</section>
<section href="ch05.html#id5204563" id="id5204563">
<title>Jump and Branch Instructions</title>
<section href="ch05.html#id5204592" id="id5204592">
<title>Jump and Branch Instructions</title>
<table href="ch05.html#Z76462" id="Z76462">
<title>Table 5-9. Jump and Branch Format Summary</title>
</table>
</section>
<section href="ch05.html#id5206482" id="id5206482">
<title>Jump and Branch Instruction Descriptions</title>
<table href="ch05.html#Z11621" id="Z11621">
<title>Table 5-10. Jump and Branch Instruction Descriptions</title>
</table>
</section>
</section>
<section href="ch05.html#id5207597" id="id5207597">
<title>Special Instructions</title>
<section href="ch05.html#id5207640" id="id5207640">
<title>Special Instruction Descriptions</title>
<table href="ch05.html#Z81460" id="Z81460">
<title>Table 5-11. Special Instruction Descriptions</title>
</table>
</section>
</section>
<section href="ch05.html#id5208006" id="id5208006">
<title>Coprocessor Interface Instructions</title>
<section href="ch05.html#id5208070" id="id5208070">
<title>Coprocessor Interface Summary</title>
<table href="ch05.html#Z97888" id="Z97888">
<title>Table 5-12. Coprocessor Interface Formats</title>
</table>
</section>
<section href="ch05.html#id5209015" id="id5209015">
<title>Coprocessor Interface Instruction Descriptions</title>
<table href="ch05.html#Z17151" id="Z17151">
<title>Table 5-13. Coprocessor Interface Instruction Descriptions</title>
</table>
</section>
</section>
</chapter>
<chapter href="ch06.html" id="Z900600312swensona">
<title>Chapter 6. Coprocessor Instruction Set</title>
<section href="ch06.html#id5209836" id="id5209836">
<title>Instruction Notation</title>
</section>
<section href="ch06.html#Z57865" id="Z57865">
<title>Floating-Point Instructions</title>
<section href="ch06.html#id5210082" id="id5210082">
<title>Floating-Point Formats</title>
<figure href="ch06.html#Z98557" id="Z98557">
<title>Figure 6-1. Floating Point Formats</title>
</figure>
</section>
<section href="ch06.html#id5210150" id="id5210150">
<title>Floating-Point Load and Store Formats</title>
<table href="ch06.html#id5210257" id="id5210257">
<title>Table 6-1. Floating-Point Load and Store Formats</title>
</table>
</section>
<section href="ch06.html#id5210969" id="id5210969">
<title>Floating-Point Load and Store Descriptions</title>
<table href="ch06.html#Z21180" id="Z21180">
<title>Table 6-2. Floating-Point Load and Store Descriptions</title>
</table>
</section>
<section href="ch06.html#id5211337" id="id5211337">
<title>Floating-Point Computational Formats</title>
<table href="ch06.html#id5211429" id="id5211429">
<title>Table 6-3. Floating-Point Computational Instructions</title>
</table>
</section>
<section href="ch06.html#id5214444" id="id5214444">
<title>Floating-Point Computational Instruction Descriptions</title>
<table href="ch06.html#Z27864" id="Z27864">
<title>Table 6-4. Floating-Point Computational Instruction Descriptions</title>
</table>
</section>
<section href="ch06.html#id5215069" id="id5215069">
<title>Floating-Point Relational Operations</title>
<table href="ch06.html#Z11463" id="Z11463">
<title>Table 6-5. Floating-Point Relational Operators</title>
</table>
</section>
<section href="ch06.html#id5217840" id="id5217840">
<title>Floating-Point Relational Instruction Formats</title>
<table href="ch06.html#id5217865" id="id5217865">
<title>Table 6-6. Floating-Point Relational Instruction Formats</title>
</table>
</section>
<section href="ch06.html#id5219866" id="id5219866">
<title>Floating-Point Relational Instruction Descriptions</title>
<table href="ch06.html#Z77592" id="Z77592">
<title>Table 6-7. Floating-Point Relational Instruction Descriptions</title>
</table>
</section>
<section href="ch06.html#id5220762" id="id5220762">
<title>Floating-Point Move Formats</title>
</section>
<section href="ch06.html#id5221561" id="id5221561">
<title>Floating-Point Move Instruction Descriptions</title>
<table href="ch06.html#id5221613" id="id5221613">
<title>Table 6-8. Floating-Point Move Instruction Descriptions</title>
</table>
</section>
</section>
<section href="ch06.html#id5221895" id="id5221895">
<title>System Control Coprocessor Instructions</title>
<section href="ch06.html#id5221920" id="id5221920">
<title>System Control Coprocessor Instruction Formats</title>
</section>
<section href="ch06.html#id5222057" id="id5222057">
<title>System Control Coprocessor Instruction Descriptions</title>
<table href="ch06.html#Z64759" id="Z64759">
<title>Table 6-9. System Control Coprocessor Instruction Descriptions</title>
</table>
</section>
<section href="ch06.html#id5222390" id="id5222390">
<title>Control and Status Register</title>
<figure href="ch06.html#Z55847" id="Z55847">
<title>Figure 6-2. Floating Control and Status Register 31</title>
</figure>
<section href="ch06.html#id5222744" id="id5222744">
<title>Exception Trap Processing</title>
</section>
<section href="ch06.html#id5222785" id="id5222785">
<title>Invalid Operation Exception</title>
</section>
<section href="ch06.html#id5222926" id="id5222926">
<title>Division-by-zero Exception</title>
</section>
<section href="ch06.html#id5223004" id="id5223004">
<title>Overflow Exception</title>
</section>
<section href="ch06.html#id5223063" id="id5223063">
<title>Underflow Exception</title>
</section>
<section href="ch06.html#id5223164" id="id5223164">
<title>Inexact Exception</title>
</section>
<section href="ch06.html#id5223198" id="id5223198">
<title>Unimplemented Operation Exception</title>
</section>
</section>
<section href="ch06.html#id5223262" id="id5223262">
<title>Floating-Point Rounding</title>
</section>
</section>
</chapter>
<chapter href="ch07.html" id="Z900599814swensona">
<title>Chapter 7. Writing Assembly Language Code</title>
<section href="ch07.html#id5223521" id="id5223521">
<title>Introduction</title>
</section>
<section href="ch07.html#id5223630" id="id5223630">
<title>Program Design</title>
<section href="ch07.html#id5223694" id="id5223694">
<title>The Stack Frame</title>
<procedure href="ch07.html#id5223782" id="id5223782">
<title>Procedure 7-1. </title>
</procedure>
</section>
<section href="ch07.html#id5225116" id="id5225116">
<title>The Shape of Data</title>
</section>
</section>
<section href="ch07.html#id5225153" id="id5225153">
<title>Examples</title>
<example href="ch07.html#Z920638453jeanw" id="Z920638453jeanw">
<title>Example 7-1. Non-leaf procedure</title>
</example>
<example href="ch07.html#Z920638476jeanw" id="Z920638476jeanw">
<title>Example 7-2. Leaf Procedure</title>
</example>
</section>
<section href="ch07.html#id5225331" id="id5225331">
<title>Interfaces Between Assembly Routines and Other Languages</title>
</section>
<section href="ch07.html#Z1049887291jeanw" id="Z1049887291jeanw">
<title>Using the .s Assembly Language File</title>
<section href="ch07.html#id5225531" id="id5225531">
<title>Program Header</title>
</section>
<section href="ch07.html#Z1049290381jeanw" id="Z1049290381jeanw">
<title>Instruction Alignment</title>
</section>
<section href="ch07.html#id5225704" id="id5225704">
<title>Label Offset Comments</title>
</section>
<section href="ch07.html#id5225821" id="id5225821">
<title>Source Code Comments</title>
</section>
<section href="ch07.html#id5225943" id="id5225943">
<title>Relative Instruction Issue Times</title>
</section>
<section href="ch07.html#id5226139" id="id5226139">
<title>Relative Branch Prediction Times</title>
</section>
<section href="ch07.html#id5226204" id="id5226204">
<title>nop Instructions</title>
</section>
<section href="ch07.html#id5226372" id="id5226372">
<title>Loop Information Comments</title>
</section>
<section href="ch07.html#id5226456" id="id5226456">
<title>Block Information</title>
</section>
</section>
</chapter>
<chapter href="ch08.html" id="Z900600225swensona">
<title>Chapter 8. Pseudo Op-Codes (Directives)</title>
<section href="ch08.html#Z920906133jeanw" id="Z920906133jeanw">
<title>Op-Codes</title>
</section>
<section href="ch08.html#id5230192" id="id5230192">
<title>PIC Assembly Code</title>
<example href="ch08.html#Z920906311jeanw" id="Z920906311jeanw">
<title>Example 8-1. KPIC directives example</title>
</example>
</section>
</chapter>
<index href="ix01.html" id="sgi-index">
<title>Index</title>
</index>
</book>
</toc>
